/*	Prova 26 Gennaio 2005

	Realizzare tre classi Thread: WorkerA,WorkerB,WorkerC
	ciascuno dei quali deve effettuare per 8 volte rispettivamente
	le attivit:
	workA,workB,workC su di una stessa catena di montaggio farm
	rispettando la precedenza:1)workA,2)workB,3)workC;

	L'oggetto condiviso farm  costituita da una matrice di interi (16x3)
	inizializzata a 0 e da un indice che rappresenta la riga
	attualmente in lavorazione. I metodi workA,workB,workC vanno a porre
	il valore 1 rispettivamente nella prima,seconda,terza colonna
	della riga in lavorazione. La lavorazione della riga successiva pu
	iniziare solo al completamento della riga precedente.

	Infine scrivere un programma che crei un oggetto della classe farm
	e avvii l'esecuzione di 2 thread WorkerA, 2 thread WorkerB,
	2 thread WorkerC che dovranno comletare il riempimento della matrice
	della farm condivisa rispettando l'ordine di lavorazione
	utilizzo i semafori in quanto bisogna rispettare la precedenza:
	1)workA,2)workB,3)workC.

	Codice: Enrico Saviano http://enrico.saviano.org
*/

class A_050126 {
	public static void main(String args[]) {
		Semaforo A, B, C;
		A = new Semaforo(1);
		B = new Semaforo(0);
		C = new Semaforo(0);
		farm fattoria = new farm();
		WorkerA A1 = new WorkerA("A1", A, B, fattoria);
		WorkerA A2 = new WorkerA("A2", A, B, fattoria);
		WorkerB B1 = new WorkerB("B1", B, C, fattoria);
		WorkerB B2 = new WorkerB("B2", B, C, fattoria);
		WorkerC C1 = new WorkerC("C1", C, A, fattoria);
		WorkerC C2 = new WorkerC("C2", C, A, fattoria);
		A1.start(); A2.start(); B1.start();
		B2.start(); C1.start(); C2.start();
	}
}

class WorkerA extends Thread {
	String nome;
	Semaforo A, B;
	farm fattoria;
	int status = 0;
	static Semaforo interno = new Semaforo(1);

	WorkerA (String nome, Semaforo A, Semaforo B, farm fattoria) {
		this.nome = nome;
		this.A = A;
		this.B = B;
		this.fattoria = fattoria;
	}
	public void run() {
		while (true) {
			A.down();
			interno.down();
			status = fattoria.workA();
			interno.up();
			B.up();
			if(status == -1) break;
		}
	}
}

class WorkerB extends Thread {
	String nome;
	int status = 0;
	Semaforo B, C;
	farm fattoria;
	static Semaforo interno = new Semaforo(1);

	WorkerB (String nome, Semaforo B, Semaforo C, farm fattoria) {
		this.nome = nome;
		this.C = C;
		this.B = B;
		this.fattoria = fattoria;
	}
	public void run() {
		while (true) {
			B.down();
			interno.down();
			status = fattoria.workB();
			interno.up();
			C.up();
			if(status == -1) break;
		}
	}
}
class WorkerC extends Thread {
	String nome;
	int status = 0;
	Semaforo C, A;
	farm fattoria;
	static Semaforo interno = new Semaforo(1);

	WorkerC (String nome, Semaforo C, Semaforo A, farm fattoria) {
		this.nome = nome;
		this.A = A;
		this.C = C;
		this.fattoria = fattoria;
	}
	public void run() {
		while (true) {
			C.down();
			interno.down();
			status = fattoria.workC();
			interno.up();
			A.up();
			if (status == -1) break;
		}
	}
}
class farm {
	static Semaforo mutex = new Semaforo(1);
	int[][] mat = new int[16][3];
	int status_code, riga = 0;

	farm() { for(int i = 0; i<3; i++) { for (int j=0; j<16; j++) { mat[j][i] = 0; } } } // Inizializzazione matrice
	public int workA() {
		mutex.down();
		if (riga < 16) { mat[riga][0]=1; status_code=0; System.out.println("workA: ["+riga+"]"+"[0] = 1;"); }
		else status_code = -1;
		mutex.up(); return status_code;
	}
	public int workB() {
		mutex.down();
		if (riga < 16) { mat[riga][1]=1; status_code=0; System.out.println("workB: ["+riga+"]"+"[1] = 1;"); }
		else status_code = -1;
		mutex.up(); return status_code;
	}
	public int workC() {
		mutex.down();
		if (riga < 16) { mat[riga][2]=1; status_code=0; System.out.println("workC: ["+riga+"]"+"[2] = 1;");	riga++; }
		else status_code = -1;
		mutex.up(); return status_code;
	}
}